```cpp
ll fac[maxn];
ll inv[maxn];

ll fpow(ll a, ll n, ll mod)
{
    ll res = 1;
    while (n)
    {
        if (n & 1)
        {
            res = res % mod * a % mod;
        }
        a = a % mod * a % mod;
        n >>= 1;
    }
    return res % mod;
}

void getfacinv(int n, ll mod)
{//初始化fac和inv数组，获取1!-n!和相应的逆元
    fac[0] = inv[0] = 1;
    for (int i = 1; i <= n; i++) fac[i] = fac[i - 1] * i % mod, lg[i] = lg[i - 1] + log(i);
    inv[n] = fpow(fac[n], mod - 2, mod);
    for (int i = n - 1; i >= 1; i--) inv[i] = inv[i + 1] * (i + 1LL) % mod;
}

ll com(ll a, ll b, ll mod)
{
    //计算组合数
    if (a < b) return 0;
    return fac[a] * inv[b] % mod * inv[a - b] % mod;
}

ll Catalan(ll n, ll mod)
{
    return ((com(n << 1, n, mod) - com(n << 1, n - 1, mod)) % mod + mod) % mod;
}
```

