```cpp
void dfs(ll x, int pos, ll phi)
{//需要线性筛(1e6)，单个素数判断，开始为dfs(x,-1,1)
 //函数运算之后ans为euler(n)==x情况下n的最小值
	if (x == 1)
	{
		ans = min(ans, phi);
		return;
	}
	if (x > sqrt(n) && (x + 1 <= 1e6 && !p.np[x + 1] || prime(x + 1)))
	{
		ans = min(ans, phi * (x + 1));
		return;
	}
	for (int i = pos + 1; i < p.prime.size() && (p.prime[i] - 1LL) <= x; i++)
	{
		if (x % (p.prime[i] - 1LL)) continue;
		ll nxt = x / (p.prime[i] - 1LL);
		ll t = phi * p.prime[i];
		dfs(nxt, i, t);
		while (nxt % p.prime[i] == 0) 
		{
			nxt /= p.prime[i];
			t *= p.prime[i];
			dfs(nxt, i, t);
		}
	}
}
```

