```cpp
long long fpow(long long a, long long n, long long mod) 
{
    if (n == 0)        return 1;
    else if (n & 1) return a * fpow(a, n - 1, mod) % mod;    
    else
    {
        long long num = fpow(a, n / 2, mod) % mod;
        return num * num % mod;
    }    
}

ll com(ll a, ll b, ll mod)
{
    //计算组合数
	if (a < b) return 0;
	return fac[a] * fpow(fac[b], mod - 2, mod) % mod * fpow(fac[a - b], mod - 2, mod) % mod;
}

ll lucas(ll a, ll b, ll mod)
{//计算极大的组合数
	if (a < b) return 0;
	if (!a) return 1;
	return lucas(a / mod, b / mod, mod) * com(a % mod, b % mod, mod) % mod;
}
```

